define(['_', 'layer', 'config'], function(_, layer, config) {
	var _model = {
		channels: {},
	};
	return {
		plusReady: function(callback) {
			if(!this.isBrowser) {
				mui.plusReady(callback);
			} else {
				callback();
			}
		},
		//系统提醒
		tips: function(msg, icon, timer) {
			timer = (timer == undefined ? 1500 : timer * 1000);
			layer.msg(msg, {
				icon: icon,
				anim: 0,
				time: timer,
				shade: 0.5,
				shadeClose: false,
			});
		},
		//系统提醒
		msg: function(title, msg, icon, timer) {
			var _msg = '<b style="font-size:1.6rem">' + title + '</b><br/><p style="color:#999">' + msg + '</p>'
			this.tips(_msg, icon, timer)
		},
		//系统弹出提醒
		alert: function(msg, icon, callback) {
			mui.alert(msg, " ", "确定", callback, "div");
			//			layer.msg(msg, {
			//				title: '',
			//				//icon: icon, 
			//				shade: 0.5,
			//				shadeClose: false,
			//				btn: ['知道了'],
			//				time: 9999999,
			//				yes: function(idx) {
			//					if(callback)
			//						callback();
			//					layer.close(idx);
			//				}
			//			});
		},
		confirm: function(msg, callback, tilte) {
			var my = this;
			//			layer.msg(msg, {
			//				time: 9999999,
			//				icon: 3,
			//				shade: 0.3,
			//				shadeClose: false,
			//				btn: ['确 定', '取 消'],
			//				yes: function(index) {
			//					if(callback)
			//						callback(true);
			//					layer.close(index);
			//				},
			//
			//			});
			var btnArray = ['确 定', '取 消'];
			if(!tilte) {
				tilte = ' ';
			}
			mui.confirm(msg, tilte, btnArray, function(e) {
				if(e.index == 1) {
					if(callback)
						callback(false);

				} else {
					if(callback)
						callback(true);
				}
			}, "div")
			//			if(mui.os.plus) {
			//				var btnArray = ['确 定', '取 消'];
			//				mui.confirm(msg, '', btnArray, function(e) {
			//					if(e.index == 1) {
			//						if(callback)
			//							callback(false);
			//
			//					} else {
			//						if(callback)
			//							callback(true);
			//					}
			//				},"div")
			//			} else {
			//				layer.confirm(msg, {
			//					//icon: 3,
			//					shade: 0.5,
			//					shadeClose: false,
			//					btn: ['确 定', '取 消'],
			//				}, function(index) {
			//					if(callback)
			//						callback(true);
			//					layer.close(index);
			//				}, function(index) {
			//					if(callback)
			//						callback(false);
			//					layer.close(index);
			//				});
			//			}

		},
		customlayer: function(msg, callback) {
			var my = this;
			layer.open({
				title: msg,
				btn: ['确 定', '取 消'],
				shadeClose: false,
				content: '<a href="tel:15387497876">拨打电话</a>'
			});
		},
		//打开新窗体
		open: function(url, params, aniShow, styles) {
			var my = this;
			if(!my.isBrowser) { //app跳转
				if(!aniShow) {
					var anType = ['slide-in-right', 'slide-in-left', 'slide-in-top', 'slide-in-bottom', 'fade-in', 'zoom-out', 'zoom-fade-out', 'pop-in'];
					var anIdx = Math.floor((Math.random() * anType.length));
					if(mui.os.ios)
						aniShow = "slide-in-right";
					else
						aniShow = "slide-in-right";
				}
				var urlParams = my.GetUrlParms(url);

				var winid = url.replace(/[^a-z]+/ig, "") + url.replace(/[^0-9]/ig, "");
			

				params = $.extend(urlParams, params);
				//				if(url == "/index.html") {
				//					winid = "HBuilder";
				//				}
				mui.openWindow({
					id: winid,
					url: url,
					extras: params,
					styles: styles,
					createNew: false,
					softinputMode: "adjustResize",
					show: {
						autoShow: true, //页面loaded事件发生后自动显示，默认为true
						aniShow: aniShow, //anType[anIdx], //页面显示动画，默认为”slide-in-right“；
						//						duration: 100 //页面动画持续时间，Android平台默认100毫秒，iOS平台默认200毫秒；
					},
					waiting: {
						autoShow: false, //自动显示等待框，默认为true
						title: config.dictionary.strings.LOADING, //等待对话框上显示的提示内容
						options: {
							//back:'none',
							background: 'rgba(0,0,0,0.75)',
							round: 5,
							loading: {
								//icon: '/img/loading-png.png',
								height: '50px',
								display: 'inline'
							}
						}
					},
				})
			} else { //浏览器跳转
				var newUrl = url;
				var newParams;
				if(params != null) {
					newParams = my.jsonCom.jsonToUrlParam(params);
					url += "?" + newParams;
				}
				//加随机参数清缓存
				if(url.indexOf('?') == -1)
					url += '?_=' + (new Date().getTime());
				else
					url += '&_=' + (new Date().getTime());
				top.location.href = url;
			}
		},
		//show:"auto": (String 类型 )自动选择动画效果
		//"none": (String 类型 )无动画效果
		//"slide-in-right": (String 类型 )从右侧横向滑动效果,对应关闭动画"slide-out-right"。
		//"slide-in-left": (String 类型 )从左侧横向滑动效果, 对应关闭动画"slide-out-left"。
		//"slide-in-top": (String 类型 )从上侧竖向滑动效果, 对应关闭动画"slide-out-top"。
		//"slide-in-bottom": (String 类型 )从下侧竖向滑动效果, 对应关闭动画"slide-out-bottom"。
		//"fade-in": (String 类型 )从透明到不透明逐渐显示效果, 对应关闭动画"fade-out"。
		//"zoom-out": (String 类型 )从小到大逐渐放大显示效果,对应关闭动画"zoom-in"。
		//"zoom-fade-out": (String 类型 )从小到大逐渐放大并且从透明到不透明逐渐显示效果, 对应关闭动画"zoom-fade-in"。
		//"pop-in": (String 类型 )从右侧平移入栈动画效果,对应关闭动画"pop-out"。
		open_app: function(url, paragms, show, styles) {
			var my = this;
			if(!mui.os.plus) {
				var newUrl = url;
				var newParams;
				if(paragms != null) {
					newParams = my.jsonCom.jsonToUrlParam(paragms);
					url += "?" + newParams;
				}
				//加随机参数清缓存
				if(url.indexOf('?') == -1)
					url += '?_=' + (new Date().getTime());
				else
					url += '&_=' + (new Date().getTime());
				top.location.href = url;
			} else {
				var aniShow = "pop-in";
				if(show) {
					aniShow = show;
				}

				//只有ios支持的功能需要在Android平台隐藏；
				if(mui.os.android) {
					//Android平台暂时使用slide-in-right动画
					if(parseFloat(mui.os.version) < 4.4) {
						aniShow = "slide-in-right";
					}
				} 
				var winid = url.replace(/[^a-z]+/ig, "") + url.replace(/[^0-9]/ig, "");
//				if(url == "/circle/resourcesinfo/index.html") {
//					winid = "HBuilder";
//				}
				 
				var extras = paragms;
				mui.openWindow({
					id: winid,
					url: url,
					styles: styles,
					extras: paragms,
					createNew: false,
					show: {
						autoShow: true, //页面loaded事件发生后自动显示，默认为true
						aniShow: aniShow, //anType[anIdx], //页面显示动画，默认为”slide-in-right“；
						duration: 200 //页面动画持续时间，Android平台默认100毫秒，iOS平台默认200毫秒；
					},
					waiting: {
						autoShow: false, //自动显示等待框，默认为true
						title: config.dictionary.strings.LOADING, //等待对话框上显示的提示内容
						options: {
							//back:'none',
							background: 'rgba(0,0,0,0.75)',
							round: 5,
							loading: {
								//icon: '/img/loading-png.png',
								height: '50px',
								display: 'inline'
							}
						},
					}
				});
			}
		},
		open_transparent: function(url, paragms, styles, showMoreBtn) {
			var my = this;
			if(my.isopening) {
				return;
			}
			//同一秒内只让一个窗体创建 避免打开相同窗体
			my.isopening = true;
			setTimeout(function() {
				my.isopening = false;
			}, 1000);

			var winid = url.replace(/[^a-z]+/ig, "") + url.replace(/[^0-9]/ig, ""); 
			var defaultStyles = {
				popGesture: "close",
				softinputMode: "adjustResize",
				hardwareAccelerated: true,
				titleNView: {
					videoFullscreen: 'landscape',
					softinputMode: "adjustResize",
					hardwareAccelerated: true,
					backgroundColor: "#f7f7f7",
					titleText: "",
					titleColor: "#000000",
					type: 'transparent',
					autoBackButton: true,
					splitLine: {
						color: '#cccccc'
					}
				}
			};
			if(styles && styles.titleNView) {
				defaultStyles.titleNView = $.extend(defaultStyles.titleNView, styles.titleNView);
				delete styles["titleNView"];
			}
			styles = $.extend(defaultStyles, styles);
			if(showMoreBtn) {
				styles.titleNView.buttons = [{
					float: "right",
					fontSize: "27px",
					fontSrc: "/fonts/mui.ttf", //wap2app内置字体文件
					text: "\ue537",
					onclick: "javascript:plus.webview.getWebviewById('" + winid + "').evalJS('loadMoreActive();')"
				}];
			}
			var webview = plus.webview.create(url, winid, styles, paragms);
			webview.addEventListener("titleUpdate", function() {
				setTimeout(function() {
					webview.show("pop-in", 300);
				}, 100);
			});
		},
		//关闭窗体
		close: function(b) {
			var my = this;
			if(b) {
				setTimeout(function() {
					if(!my.isBrowser) {
						var ws = plus.webview.currentWebview();
						plus.webview.close(ws);
					} else
						history.back();
				}, 500)
			} else {
				if(!my.isBrowser) {
					var ws = plus.webview.currentWebview();
					plus.webview.close(ws);
				} else
					history.back();
			}
		},
		callback: function(callbackname, options) {
			if(!this.isBrowser) {
				var parent = plus.webview.currentWebview().opener()
				mui.fire(parent, callbackname, options); //刷新父页面
			}
		},
		callbackFixed: function(url, callbackname, options) {
			if(!this.isBrowser) {
				var wvs = plus.webview.all();
				for(var i = 0, len = wvs.length; i < len; i++) {
					if(wvs[i].getURL().indexOf(url) > 0) {
						mui.fire(wvs[i], callbackname, options); //刷新父页面
					}
				}
			}
		},
		openChildView: function(url, paragms, show, styles) {
			var my = this;
			if(my.isopening) {
				return;
			}
			my.isopening = true;
			setTimeout(function() {
				my.isopening = false;
			}, 500);

			if(!show) {
				show = "none";
			}
			var styles = $.extend({
				position: "static",
				left: "0px",
				top: "0px",
				scrollIndicator: 'none',
				background: "transparent",
				popGesture: 'none'
			}, styles);
			var extras = paragms;
			my.open(url,paragms,show,styles);
//			// 创建侧滑页面
//			var childView = plus.webview.create(url, url, styles, extras);
//			// 侧滑页面关闭后关闭遮罩
//			childView.addEventListener('close', function() {
//				childView = null;
//			}, false);
//			// 侧滑页面加载后显示（避免白屏）
//			childView.addEventListener("loaded", function() {
//				childView.show(show, 300);
//			}, false);
		},
		openInfoView: function(id, category) {
			var my = this;
			if(category == "1") {
				my.open_transparent(config.urlCONFIG.common.url.info_video, {
					resourcesid: id
				}, {
					titleNView: {
						titleText: "视频详情"
					}
				}, true);
			} else {
				my.open(config.urlCONFIG.common.url.info_image, {
					resourcesid: id
				});
			}
		},
		exit: function() {
			plus.runtime.quit();
		},
		//双击返回退出APP
		backExit: function() {

			var my = this;
			var _clickNum = 0;

			mui.init({
				beforeback: function() {
					_clickNum++;
					if(_clickNum > 1) {
						plus.runtime.quit();
					} else {
						my.msg("提示", "再按一次退出应用", 0);
					}
					setTimeout(function() {
						_clickNum = 0;
					}, 1000);
					return false;
				}
			});
		},
		//获取当前页面ID
		currPageId: function(callback) {
			var my = this;
			if(my.isBrowser)
				callback(location.href);
			else {
				mui.plusReady(function() {
					callback(plus.webview.getLaunchWebview().getURL());
				});
			}
		},
		//获取页面参数
		getParam: function() {
			var wv = plus.webview.currentWebview();
			return wv;
		},
		//获取URL所有参数
		GetUrlParms: function(url) {
			var args = new Object();
			var query = "";
			if(url && url.indexOf("?") > -1) {
				query = url.substring(url.indexOf("?") + 1);
			} else {
				query = location.search.substring(1); //获取查询串	
			}

			var pairs = query.split("&"); //在逗号处断开
			for(var i = 0; i < pairs.length; i++) {
				var pos = pairs[i].indexOf('='); //查找name=value
				if(pos == -1) continue; //如果没有找到就跳过
				var argname = pairs[i].substring(0, pos); //提取name
				var value = pairs[i].substring(pos + 1); //提取value
				args[argname] = decodeURIComponent(value); //存为属性
			}

			if(!url && !this.isBrowser) {
				var wvO = plus.webview.currentWebview();
				var wv = this.cloneJSON(wvO);
				delete wv["__view_array__"];
				delete wv["__IDENTITY__"];
				delete wv["__uuid__"];
				delete wv["__callbacks__"];
				delete wv["__callback_id__"];
				delete wv["id"];
				args = $.extend(wv, args);
			}
			return args;

		},
		cloneJSON: function(para) {
			var rePara = null;
			var type = Object.prototype.toString.call(para);
			if(type.indexOf("Object") > -1) {
				rePara = $.extend(true, {}, para);
			} else if(type.indexOf("Array") > 0) {
				rePara = [];
				$.each(para, function(index, obj) {
					rePara.push($.cloneJSON(obj));
				});
			} else {
				rePara = para;
			}
			return rePara;
		},
		//是否是普通浏览器打开
		isBrowser: !mui.os.plus,
		//是否是ios操作系统
		isIOS: (mui.os.plus && mui.os.ios),
		//是否是Android操作系统
		isAndroid: (mui.os.plus && mui.os.android),
		//是否需要开启沉浸式状态栏
		isBar: function() {
			return this.isIOS;
		},
		//是否是微信打开
		isWx: function() {
			var ua = window.navigator.userAgent.toLowerCase();
			if(ua.match(/MicroMessenger/i) == 'micromessenger') {
				return true;
			} else {
				return false;
			}
		},
		//loading弹出层
		loading: function() {
			var box = $('#loading-layout');
			if(box.length == 0) {
				$('body').append('<div id="loading-layout"><div class="loading"></div></div>');
				box = $('#loading-layout');
			}
			var box_loading = $('#loading-layout .loading');
			var width = box.width();
			var height = box.height();
			var width_loading = box_loading.width();
			var height_loading = box_loading.height();
			$('#loading-layout .loading').css('top', (height - height_loading) / 2 + 'px')
			$('#loading-layout .loading').css('left', (width - width_loading) / 2 + 'px')
			box.show();
		},
		//关闭弹出层
		loadingClose: function(timer) {
			setTimeout(function() {
				$('#loading-layout').remove();
			}, (timer ? timer : 0))
		},
		//禁用按钮
		disableBtn: function($btn, timer) {
			if(!timer) {
				timer = 500;
			}
			$btn.attr("disabled", "disabled");
			setTimeout(function() {
				$btn.removeAttr("disabled", "disabled");
			}, timer);
		},
		//时间显示
		toShowTimeString: function(time) {
			try {
				var nowdate = new Date();
				var year = parseInt(time.substr(0, 4));
				var month = parseInt(time.substr(5, 2));
				var day = parseInt(time.substr(9, 2));
				if(year == nowdate.getFullYear() && (month + 1) == nowdate.getMonth()) {
					if(day == nowdate.getDate()) {
						return date.getHours() + ":" + date.getMinutes();
					} else if(day + 1 == nowdate.getDate()) {
						return "昨天";
					} else {
						return time.substr(0, 10);
					}
				}
				return time;

			} catch(e) {
				return "";
			}

		},
		toShowNumberString: function(num) {
			if(!num) return 0;
			var num = parseInt(num);
			return num > 9999 ? (Math.floor(num / 1000) / 10) + '万' : num;
		},
		/******* http 请求 *******/

		//请求 get
		get_synchro: function(url, params, callback, callbackErr) {
			var my = this;
			if(!config.appCONFIG.netStatus) {
				//my.tips(,2)
				my.tips(config.dictionary.strings.NO_NET_POST, 0);
				if(callbackErr)
					callbackErr(config.dictionary.strings.NO_NET_POST);
				return false;
			}
			if(my.getUserInfo() && url) {
				url = url.replace('[key]', my.getUserInfo().Token).replace('[key]', my.getUserInfo().Token)
					.replace('[userid]', my.getUserInfo().UserID).replace('[userid]', my.getUserInfo().UserID);
			}
			if(!url) {
				console.log("请求为空");
				//				debugger;
				if(callback) {
					callback(null);
				}
				return;
			}

			//console.log("==========================================getUrl:" + url);
			//console.log("==========================================getparams:" + JSON.stringify(params));

			$.ajax({
				url: url,
				type: 'GET', //GET
				async: false, //或false,是否异步
				data: params,
				timeout: 80000, //超时时间
				dataType: 'json',
				success: function(data, textStatus, jqXHR) {
					callback && callback(data);
				},
				error: function(xhr, textStatus) {
					//					console.log("GET请求异常：" + JSON.stringify(xhr));
					my.loadingClose();
					if(textStatus == "error")
						my.tips(config.dictionary.strings.SERVER_ERROR, 0);
					else if(textStatus == "timeout")
						my.tips(config.dictionary.strings.TIMEOUT, 0);
					else {
						var jsonXhr = JSON.parse(xhr.responseText);
						my.tips(jsonXhr.msg, 0);

					}
					if(callbackErr) {

						callbackErr(xhr, textStatus);
					}
				},
				complete: function() {
					//my.loadingClose();
				}
			})
		},

		//请求 get
		get: function(url, params, callback, callbackErr) {
			var my = this;
			if(!config.appCONFIG.netStatus) {
				//my.tips(,2)
				my.tips(config.dictionary.strings.NO_NET_POST, 0);
				if(callbackErr)
					callbackErr(config.dictionary.strings.NO_NET_POST);
				return false;
			}
			if(my.getUserInfo() && url) {
				url = url.replace('[key]', my.getUserInfo().Token).replace('[key]', my.getUserInfo().Token)
					.replace('[userid]', my.getUserInfo().UserID).replace('[userid]', my.getUserInfo().UserID);
			}
			if(!url) {
				console.log("请求为空");
				//				debugger;
				if(callback) {
					callback(null);
				}
				return;
			}

			//console.log("==========================================getUrl:" + url);
			//console.log("==========================================getparams:" + JSON.stringify(params));

			$.ajax({
				url: url,
				type: 'GET', //GET
				async: true, //或false,是否异步
				data: params,
				timeout: 80000, //超时时间
				dataType: 'json',
				success: function(data, textStatus, jqXHR) {
					callback && callback(data);
				},
				error: function(xhr, textStatus) {
					//					console.log("GET请求异常：" + JSON.stringify(xhr));
					my.loadingClose();
					if(textStatus == "error")
						my.tips(config.dictionary.strings.SERVER_ERROR, 0);
					else if(textStatus == "timeout")
						my.tips(config.dictionary.strings.TIMEOUT, 0);
					else {
						var jsonXhr = JSON.parse(xhr.responseText);
						my.tips(jsonXhr.msg, 0);

					}
					if(callbackErr) {

						callbackErr(xhr, textStatus);
					}
				},
				complete: function() {
					//my.loadingClose();
				}
			})
		},

		//http 请求 post
		post: function(url, params, callback, callbackErr) {
			//console.log(config.appCONFIG.netStatus)
			var my = this;
			if(!config.appCONFIG.netStatus) {
				//my.tips(config.dictionary.strings.NO_NET_POST,2)
				my.tips(config.dictionary.strings.NO_NET_POST, 0);
				if(callbackErr)
					callbackErr(config.dictionary.strings.NO_NET_POST);
				return false;
			}
			if(my.getUserInfo() && url) {
				url = url.replace('[key]', my.getUserInfo().Token).replace('[key]', my.getUserInfo().Token)
					.replace('[userid]', my.getUserInfo().UserID).replace('[UserId]', my.getUserInfo().UserID);
			}
			//console.log('==========================================postUrl:' + url);
			//console.log("==========================================postparams:" + JSON.stringify(params));
			$.ajax({
				url: url,
				type: 'POST', //GET
				async: true, //或false,是否异步
				data: JSON.stringify(params),
				timeout: 80000, //超时时间
				contentType: "application/json;charset=utf-8",
				dataType: 'json',
				success: function(data, textStatus, jqXHR) {
					my.loadingClose();
					callback(data);
				},
				error: function(xhr, textStatus) {
					my.loadingClose();
					if(textStatus == "timeout")
						my.tips(config.dictionary.strings.TIMEOUT, 0);
					else {
						try {
							var jsonXhr = JSON.parse(xhr.responseText);
						} catch(err) {
							if(textStatus == "error")
								my.tips(config.dictionary.strings.SERVER_ERROR, 0);
						}
					}
					if(callbackErr) {

						callbackErr(xhr, textStatus);
					}

				},
				complete: function() {

				}
			})
		},
		//系统自动更新
		update: function() {
			if(window.plus) {
				this.updateCheck();
			} else {
				document.addEventListener('plusready', this.updateCheck, false);
			}
		},
		//系统升级检测
		updateCheck: function() {
			var my = this;
			var appVer = ''; //app版本
			var newVer = ''; //最新版本 
			//获得当前版本
			plus.runtime.getProperty(plus.runtime.appid, function(inf) {
				appVer = inf.version;
				//console.log(appVer);
				//$('.copyright').html('湖南互联移动科技有限公司提供技术支持v' + appVer);
				//发起新版本请求检测
				my.get(config.urlCONFIG.common.url.update_path + "/version.html?v=" + (new Date().getTime()), {}, function(data) {
					newVer = data.version;
					//	console.log(newVer);
					fileType = (data.fileType ? data.fileType : 'wgt');
					if(appVer != newVer && parseInt(appVer.replaceAll('\\.', '')) < parseInt(newVer.replaceAll('\\.', ''))) {
						my.confirm("检查到有新版本，是否立即更新", function(d) {
							if(d) {
								var waiting = plus.nativeUI.showWaiting("有新版本啦，正在下载更新 0%...", {
									width: '100%',
									height: '100%',
									//back: 'none',
									round: 1,
								});
								console.log(config.urlCONFIG.common.url.update_path + "/" + newVer + "." + fileType + "?_=" + (new Date().getTime()))
								//下载更新包					
								var file_downing = plus.downloader.createDownload(config.urlCONFIG.common.url.update_path + "/" + newVer + "." + fileType + "?_=" + (new Date().getTime()), {
									filename: "_doc/update/"
								}, function(d, status) {
									if(status == 200) {
										var _filename = d.filename;
										// 安装更新包
										plus.runtime.install(_filename, {}, function() {
											//更新完毕删除更新包
											plus.io.resolveLocalFileSystemURL(_filename, function(entity) {
												entity.remove();
											}, function(error) {
												debugCom.log(error.message);
											});
											//应用重启并显示启动页
											plus.storage.removeItem('lauchFlag')
											//如果是安卓自动重启应用，ios需要手动重启应用
											if(mui.os.android) {
												waiting.setTitle('更新完成，正在重新打开应用...');
												setTimeout(function() {
													plus.nativeUI.closeWaiting();
													plus.runtime.restart();
												}, 1000)
											} else {
												plus.nativeUI.closeWaiting();
												mui.alert('更新完成，请彻底结束应用并重新打开！', '', function() {
													//plus.runtime.restart();
												})
											}

										}, function(e) {
											waiting.setTitle('更新失败:' + e.message);
											setTimeout(function() {
												plus.nativeUI.closeWaiting();
											}, 2000);
										});
									} else {
										mui.toast('下载更新包出现问题:' + status)
									}
								});
								//下载百分比
								file_downing.addEventListener("statechanged", function() {
									var per = parseInt(file_downing.downloadedSize / file_downing.totalSize * 100);
									per = (per == NaN ? 0 : per);
									waiting.setTitle("有新版本啦，正在下载更新 " + per + "%");
								}, false);
								//开始下载
								file_downing.start();
							}

						})
					} else {
						my.tips("当前已是最新版本", 0)
					}

				});
			})
		},
		/********验证********/
		validaCom: {
			//验证正则
			_regex: {
				mobile: /^1+\d{10}$/,
				isIDCard: /^\d{17}[\d|X|x]$|^\d{15}$/,
				email: /^([a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+((.[a-zA-Z0-9_-]{2,3}){1,2})$/,
				integer: /^[0-9]*[1-9][0-9]*$/,
				mobile_Landline: /^(0?(13[0-9]|15[012356789]|17[013678]|18[0-9]|14[57])[0-9]{8})|(400|800)([0-9\\-]{7,10})|(([0-9]{4}|[0-9]{3})(-| )?)?([0-9]{7,8})((-| |转)*([0-9]{1,4}))?$/,
			},
			//验证手机和座机
			isMobile_Landline: function(txt) {
				return this._regex.mobile_Landline.test(txt);
			},
			//验证手机
			isMobile: function(txt) {
				return this._regex.mobile.test(txt);
			},
			//验证邮箱
			isEmail: function(txt) {
				return this._regex.email.test(txt);
			},
			//身份证验证
			isIDCard: function(txt) {
				return this._regex.isIDCard.test(txt);
			},
			//验证正整数
			isIneger: function(txt) {
				return this._regex.integer.test(txt);
			}
		},
		/********json操作********/
		jsonCom: {
			//将json转成url参数
			jsonToUrlParam: function(param, key) {
				var my = this;
				var paramStr = "";

				if(param instanceof String || param instanceof Number || param instanceof Boolean) {
					paramStr += "&" + key + "=" + encodeURIComponent(param);
				} else {
					$.each(param, function(i, item) {
						var k = key == null ? i : key + (param instanceof Array ? "[" + i + "]" : "." + i);
						if(!item) {
							paramStr += '&' + k + "=";
						} else {
							paramStr += '&' + my.jsonToUrlParam(this, k);
						}

					});
				}
				return paramStr.substr(1);
			},
			//将url参数转成json
			urlParamToJson: function(url) {
				if(url.indexOf("?") > -1) {
					var string_a = url.split('?')[1];
					if(string_a.length > 0) {
						var string = string_a.split('&');
						var res = {};
						for(var i = 0; i < string.length; i++) {
							var str = string[i].split('=');
							res[str[0]] = str[1];
						}
						return res;
					} else
						return null;
				} else
					return null;

			}
		},
		/********数据存储********/
		dataCom: {
			set: function(key, data) {
				localStorage.setItem(key, data);
			},
			get: function(key) {
				return localStorage.getItem(key);
			},
			remove: function(key) {
				localStorage.removeItem(key)
			},
			clear: function() {
				var my = this;
				localStorage.clear();
			}
		},
		/*********** 网络监测 *************/
		netCom: {
			page: this,
			init: function() {
				var my = this;
				//网络检测
				mui.plusReady(function() {
					if(plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_NONE) {
						config.netStatus = false;
						//my.tips(config.dictionary.strings.NO_NET,2);
						my.page.msg("提示", config.dictionary.strings.NO_NET, 0);
					}
					document.addEventListener("netchange", my.change, false);
				});
			},
			change: function() {
				var my = this;
				mui.plusReady(function() {
					//获取当前网络类型
					var nt = plus.networkinfo.getCurrentType();
					switch(nt) {
						case plus.networkinfo.CONNECTION_ETHERNET:

						case plus.networkinfo.CONNECTION_WIFI:

						case plus.networkinfo.CONNECTION_CELL2G:

						case plus.networkinfo.CONNECTION_CELL3G:

						case plus.networkinfo.CONNECTION_CELL4G:
							if(!config.netStatus) {
								//my.tips(config.dictionary.strings.YES_NET,1);
								my.page && my.page.msg("提示", config.dictionary.strings.YES_NET, 0);
							}
							config.netStatus = true;
							break;
						default:
							if(config.netStatus) {

								//	my.tips(config.dictionary.strings.NO_NET,2);
								my.page && my.page.msg("提示", config.dictionary.strings.NO_NET, 0);
							}
							config.netStatus = false;
							break;
					}
				});
			}
		},
		//		*******点击打开我的二维码***********
		openCode: function() {
			var my = this;
			var user = my.getUserInfo();
			if(user) {
				var t = "";
				if(my.isWx()) {
					my.get(config.urlCONFIG.wx_createwxqrcode, {
						memberid: user.MemberID
					}, function(data) {
						if(data.result) {
							var ticket = data.data;
							var url = 'https://mp.weixin.qq.com/cgi-bin/showqrcode?ticket=' + ticket
							t += '<div style="position: relative; height: 100%; z-index: 10;">';
							t += '<div class="popup-min"><div class="my-code"><img class="img1" src="' + url + '" alt="" />';
							//t += '</div>';
							t += '<div class="toux"><img src="' + user.HeadImgUrl + '" alt="" /></div></div>';
							t += '<div class="xinxi"><div class="img2"><img src="' + user.HeadImgUrl + '" alt="" /></div>';
							t += '<div class="test"><p class="name">' + user.Name + '</p><p class="vip">' + user.LevelName + '</p></div></div></div></div>'
							$("#popup").html(t);
						}
					});
				} else {
					my.post(config.urlCONFIG.login.api.api_getQACode, {
							memberid: user.MemberID
						},
						function(data) {
							if(data.result) {
								console.log(JSON.stringify(data.data))
								t += '<div style="position: relative; height: 100%; z-index: 10;">';
								t += '<div class="popup-min"><div class="my-code"><img class="img1" src="' + data.data.myqrcode + '" alt="" />';
								//t += '</div>';
								t += '<div class="toux"><img src="' + user.HeadImgUrl + '" alt="" /></div></div>';
								t += '<div class="xinxi"><div class="img2"><img src="' + user.HeadImgUrl + '" alt="" /></div>';
								t += '<div class="test"><p class="name">' + user.Name + '</p><p class="vip">' + user.LevelName + '</p></div></div></div></div>'
								$("#popup").html(t);
							} else {
								//console.log(JSON.stringify(data));
								my.alert(data.msg);
							}
						});

				}

				//二维码点击事件
				$("#code").on("tap", function() {
					$("#popup").show();
				});
				$("#popup").on("tap", function() {
					$("#popup").hide();
				});
			} else {
				my.open(config.urlCONFIG.login.url.login);
			}

		},
		//*******点击打开选取相册***********
		openPicture: function(id) {
			var html = '<ul class="mui-table-view">';
			html += '<li class="mui-table-view-cell bg-xg"><a href="#" class="frompz">拍照</a></li>'
			html += '<li class="mui-table-view-cell bg-xg"><a href="#" class="fromxc">从相册中选择</a></li>';
			html += '<li class="mui-table-view-cell bg-xg bg-hui"><a href="#picture"><b>取消</b></a></li>';
			html += '</ul>';
			if(id) {
				$(id).html(html);
			} else {
				$("#picture").html(html);
			}

		},
		sliderGroup: function(data, options) {
			options = $.extend({
				id: "",
				urlFiled: "",
				titleFiled: "",
				indicatorShow: true,
				onClick: null
			}, options);
			if(!data) return;
			$("#" + options.id).show();
			var htmlGroup = '';
			var htmlIndicator = ''
			var $firstItem = '';
			var $lastItem = '';
			var $slidergroup = $('<div class="mui-slider-group mui-slider-loop"></div>');
			var $sliderindicator = $('<div  class="mui-slider-indicator mui-text-center" style="bottom: 0px;"></div>');
			$.each(data, function(i, item) {
				var htmlTemp = "";
				if(options.titleFiled) {
					htmlTemp = '<div class="mui-slider-item"><a   data-index="' + i + '"  ><img src="' + item[options.urlFiled] + '"></a><p class="mui-slider-title">' + (item[options.titleFiled] || '') + '</p></div>';
				} else {
					htmlTemp = '<div class="mui-slider-item"><a   data-index="' + i + '"  ><img src="' + item[options.urlFiled] + '"></a></div>';
				}

				htmlGroup += htmlTemp;
				if(i == 0) {
					$firstItem = $(htmlTemp).addClass("mui-slider-item-duplicate");
					htmlIndicator += '<div class="mui-indicator mui-active"></div>';
				} else {
					htmlIndicator += '<div class="mui-indicator"></div>';
				}
				if(i == data.length - 1) {
					$lastItem = $(htmlTemp).addClass("mui-slider-item-duplicate");
				}
			});
			if($lastItem) {
				htmlGroup = $lastItem[0].outerHTML + htmlGroup;
			}
			if($firstItem) {
				htmlGroup = htmlGroup + $firstItem[0].outerHTML;
			}

			$slidergroup.html(htmlGroup);
			var $sliderContainer = $("#" + options.id);
			if(!$sliderContainer.hasClass("mui-slider")) {
				$sliderContainer.addClass("mui-slider");
			}
			$sliderContainer.empty();
			$sliderContainer.append($slidergroup);
			if(data.length > 1) {
				if(options.indicatorShow) {
					$sliderindicator.html(htmlIndicator);
					$sliderContainer.append($sliderindicator);
				}
				mui('#' + options.id).slider({
					interval: 5000
				}).gotoItem(0);
				mui('#' + options.id).slider().setStopped(false);
			} else {
				mui('#' + options.id).slider().setStopped(true);
			}
			if(options.onClick) {
				$("#" + options.id + " a").on("tap", function() {
					var index = $(this).attr('data-index');
					if(parseInt(index) < data.length) {
						options.onClick(data[parseInt(index)]);
					}
				})
			}

		},
		//图片加载失败显示的图片
		errUlr: function() {
			return {
				errorurl: "this.src='../../img/images/error.png'"
			}
		},
		//获取用户信息
		getUserInfo: function() {
			var my = this;
			var userData = my.dataCom.get("user");
			var jsonData = null;
			if(userData) {
				jsonData = JSON.parse(userData);
			} else {
				//				jsonData = {
				//					UserID: "98B0373E6F9041A098767CEAAC898D46",
				//					Token: "98B0373E6F9041A098767CEAAC898D46"
				//				}
			}
			return jsonData;
		},
		checkUserLogin: function() {
			var my = this;
			var b = false;
			var userData = my.dataCom.get("user");
			if(userData != null) {
				var jsonData = JSON.parse(userData);
				if(jsonData) {
					my.get_synchro(config.urlCONFIG.login.api.UserIDLogin, {
						userid: jsonData.UserID
					}, function(data) {
						if(!data.result) {
							my.alert(data.msg, 0, function() {
								var account = my.dataCom.get("account");
								my.dataCom.clear();
								my.dataCom.set('account', account);
								my.open(config.urlCONFIG.login.url.login);
								b = false;
							})
						} else {
							b = true;
						}
					});
					return b;
				} else {
					var account = my.dataCom.get("account");
					my.dataCom.clear();
					my.dataCom.set('account', account);
					my.open(config.urlCONFIG.login.url.login);
					return false;
				}
			} else {
				var account = my.dataCom.get("account");
				my.dataCom.clear();
				my.dataCom.set('account', account);
				my.open_app(config.urlCONFIG.login.url.login);
				return false;
			}
		},
		//更新登录数据
		updateLoginUserInfo: function(callback) {
			var my = this;
			my.post(config.urlCONFIG.login.api.api_login, {
				LoginID: my.getUserInfo().LoginID,
				Password: my.getUserInfo().Password,
			}, function(data) {
				if(data.result) {
					my.dataCom.set('user', JSON.stringify(data.data));
					callback();
				}
			});
		},
		//打开键盘
		openSoftKeyboard: function() {
			mui.ready(function() {
				if(mui.os.ios) {
					var webView = plus.webview.currentWebview().nativeInstanceObject();
					webView.plusCallMethod({
						"setKeyboardDisplayRequiresUserAction": false
					});
				} else {
					var webview = plus.android.currentWebview();
					plus.android.importClass(webview);
					webview.requestFocus();
					var Context = plus.android.importClass("android.content.Context");
					var InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
					var main = plus.android.runtimeMainActivity();
					var imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
					imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
				}
			});
		},
		/* 支付封装 */
		payCom: {
			getChannels: function(callback) {
				var my = this;
				mui.plusReady(function() {
					// 获取支付通道
					plus.payment.getChannels(function(channels) {
						_model.channels = channels;
					}, function(e) {
						_model.channels = null;
						console.log("获取支付通道失败：" + e.message);
					});
				})
			},
			request: function(payType, payData, callback, callbackErr) {
				var my = this;
				mui.plusReady(function() {
					if(_model.channels.length == 0) {
						my.tips("支付请求失败：无法获取支付通道~", 2);
						//my.msg("提示", "支付请求失败：无法获取支付通道~", 0);
						return;
					}
					var channel = {};
					$.each(_model.channels, function(idx, item) {
						if(item.id == payType)
							channel = item;
					});
					if(channel.length == 0) {
						my.tips("支付请求失败：不支持此支付类型~", 2);
						//my.msg("提示", "支付请求失败：不支持此支付类型~", 0);
						return;
					}
					//					console.log(JSON.stringify(channel));
					//					console.log(payData);

					plus.payment.request(channel, payData, function(result) {
						if(callback)
							callback(result);
					}, function(error) {
						if(callbackErr)
							callbackErr(error);
					})
				});
			},

			//微信JS准备
			preWeiXinJSBridge: function(data, callback) {
				var my = this;
				if(typeof WeixinJSBridge == "undefined") {
					if(document.addEventListener) {
						document.addEventListener('WeixinJSBridgeReady', onBridgeReady, false);
					} else if(document.attachEvent) {
						document.attachEvent('WeixinJSBridgeReady', onBridgeReady);
						document.attachEvent('onWeixinJSBridgeReady', onBridgeReady);
					}
				} else {
					my.onBridgeReady(data, callback);
				}
			},

			//公众号支付统一下单
			onBridgeReady: function(data, callback) {
				var my = this;
				WeixinJSBridge.invoke(
					'getBrandWCPayRequest', JSON.parse(data),
					function(res) {
						if(res.err_msg == "get_brand_wcpay_request:ok") {
							callback(true);
						}
					}
				);
			},

		},

	}
});