var selectAreaData = {
	province: "",
	provincename: "",
	city: "",
	cityname: "",
	county: "",
	countyname: "",
	town: "",
	townname: ""
};
require(["common", "config"], function(com, config) {
	var gallery = mui('#modal .mui-slider');

	createprovice();

	document.getElementById('slider').addEventListener('slide', function(e) {
		if(e.detail.slideNumber === 0) {

		} else if(e.detail.slideNumber === 1) {
			if($(".topcity").hasClass("none")) {
				gallery.slider().gotoItem(e.detail.slideNumber - 1);
			}
		} else if(e.detail.slideNumber === 2) {
			if($(".topcounty").hasClass("none")) {
				gallery.slider().gotoItem(e.detail.slideNumber - 1);
			}
		} else if(e.detail.slideNumber === 3) {
			if($(".toptown").hasClass("none")) {
				gallery.slider().gotoItem(e.detail.slideNumber - 1);
			}
		}
	});

	//点击弹出层灰色遮罩区域关闭弹出层
	$('#modal #model-close-div').on('tap', function() {
		$(this).parent().removeClass('mui-active');
		zoom(false);
	});

	$('#modal .btncancel').on('tap', function() {
		$("#modal").removeClass('mui-active');
		zoom(false);
	});

	$('#modal .btnok').on('tap', function() {
		if(setAddressData) {
			setAddressData(selectAreaData);
		}
		$("#modal").removeClass('mui-active');
		zoom(false);
	});

	function createprovice() {
		com.get(config.urlCONFIG.common.api.GetAdministrativeArea, {
			parentCode: "156"
		}, function(data) {
			//console.log(JSON.stringify(data));
			if(data.result) {
				var html = "";
				$.each(data.data, function(index, item) {
					html += '<li class="mui-table-view-cell" data-text="' + item.DivisionName + '" data-value="' + item.DivisionCode + '">';
					html += '<a style="float:left;" class="mui-navigate-right">' + item.DivisionName + '</a>';
					html += '<span data-value="' + item.DivisionCode + '" class="mui-icon mui-icon-arrowright" style="float:right;margin-right: -50px;text-align: right;width: 100px;"></span>';
					html += '</li>';
				});
				$('#provincescroll ul').html(html);

				$("#provincescroll li").on('tap', function() {
					var text = $(this).attr("data-text");
					var value = $(this).attr("data-value");
					$('.topprovince').html(text);
					selectAreaData.province = value;
					selectAreaData.provincename = text;
					selectAreaData.city = "";
					selectAreaData.cityname = "";
					selectAreaData.county = "";
					selectAreaData.countyname = "";
					selectAreaData.town = "";
					selectAreaData.townname = "";
					$('.topcity').html("请选择");
					$(".topcounty").addClass("none");
					$(".toptown").addClass("none");
					createcity(value, function(data) {
						$(".topcity").removeClass("none");
					});
				});

				$("#provincescroll li span").on('tap', function() {
					var value = $(this).attr("data-value");
					$('.topcity').html("请选择");
					$(".topcounty").addClass("none");
					$(".toptown").addClass("none");
					createcity(value, function(data) {
						$(".topcity").removeClass("none");
						gallery.slider().gotoItem(1);
					});

				});
			}
		});

	};

	function createcity(value, callback) {
		com.get(config.urlCONFIG.common.api.GetAdministrativeArea, {
			parentCode: value
		}, function(data) {
			//console.log(JSON.stringify(data));
			if(data.result) {
				var html = "";
				$.each(data.data, function(index, item) {
					html += '<li class="mui-table-view-cell" data-text="' + item.DivisionName + '" data-value="' + item.DivisionCode + '">';
					html += '<a style="float:left;" class="mui-navigate-right">' + item.DivisionName + '</a>';
					html += '<span data-value="' + item.DivisionCode + '" class="mui-icon mui-icon-arrowright" style="float:right;margin-right: -50px;text-align: right;width: 100px;"></span>';
					html += '</li>';
				});
				$('#cityscroll ul').html(html);

				$("#cityscroll li").on('tap', function() {
					var text = $(this).attr("data-text");
					var value = $(this).attr("data-value");
					$('.topcity').html(text);
					selectAreaData.city = value;
					selectAreaData.cityname = text;

					selectAreaData.county = "";
					selectAreaData.countyname = "";
					selectAreaData.town = "";
					selectAreaData.townname = "";
					$('.topcounty').html("请选择");
					$(".toptown").addClass("none");
					createcounty(value, function(data) {
						$(".topcounty").removeClass("none");

					});
				});

				$("#cityscroll li span").on('tap', function() {
					var value = $(this).attr("data-value");
					$('.topcounty').html("请选择");
					$(".toptown").addClass("none");
					createcounty(value, function(data) {
						$(".topcounty").removeClass("none");
						gallery.slider().gotoItem(2);
					});

				});
				if(callback) {
					callback(true);
				}
			}
		});
	};

	function createcounty(value, callback) {
		com.get(config.urlCONFIG.common.api.GetAdministrativeArea, {
			parentCode: value
		}, function(data) {
			if(data.result) {
				var html = "";
				$.each(data.data, function(index, item) {
					html += '<li class="mui-table-view-cell" data-text="' + item.DivisionName + '" data-value="' + item.DivisionCode + '">';
					html += '<a style="float:left;" class="mui-navigate-right">' + item.DivisionName + '</a>';
					html += '</li>';
				});
				$('#countyscroll ul').html(html);

				$("#countyscroll li").on('tap', function() {
					var text = $(this).attr("data-text");
					var value = $(this).attr("data-value");
					$('.topcounty').html(text);
					selectAreaData.county = value;
					selectAreaData.countyname = text;
					selectAreaData.town = "";
					selectAreaData.townname = "";
				});

				if(callback) {
					callback(true);
				}
			}
		});
	};

	function createtown(value, callback) {
		com.get(config.urlCONFIG.common.api.GetAdministrativeArea, {
			parentCode: value
		}, function(data) {
			//console.log(JSON.stringify(data));
			if(data.result) {
				var html = "";
				$.each(data.data, function(index, item) {
					html += '<li class="mui-table-view-cell" data-text="' + item.DivisionName + '" data-value="' + item.DivisionCode + '">';
					html += '<a style="float:left;" class="mui-navigate-right">' + item.DivisionName + '</a>';
					html += '</li>';
				});
				$('#townscroll ul').html(html);

				$("#townscroll li").on('tap', function() {
					mui('.mui-slider').slider().setStopped(false);
					var text = $(this).attr("data-text");
					var value = $(this).attr("data-value");
					selectAreaData.town = value;
					selectAreaData.townname = text;

				});
				if(callback) {
					callback(true);
				}
			}
		});
	};

});