define([], function() {
	var apiHost = "http://ydtvapi.158shopping.com/"; 
	var webHost = "/";
	if(!mui.os.plus) {
		webHost = "http://127.0.0.1:8020/yd_app/";
	}
 
	var upHost = "http://ydapi.158shopping.com/"
	return {
		/****** app全局配置 *****/
		appCONFIG: {
			appName: "艺斗",
			apiHost: apiHost,
			netStatus: true, //是否链接网络
			debug: true, //调试模式	   
			pageSize: 20, //列表分页大小
		},
		/****** 常量配置 *****/
		dictionary: {
			strings: {
				LOADING: "拼命加载中...",
				NO_NET: "网络异常，请检查网络设置~",
				NO_NET_POST: "网络中断，无法请求数据~",
				YES_NET: "网络链接成功~",
				LOGIN_EMPTY: "帐号密码不能为空~",
				NO_DATA: "没有数据~",
				TIMEOUT: "请求服务器超时，请检查网络~",
				SERVER_ERROR: "请求服务器时没有响应~",
				INVALID_TOKEN: "令牌错误",
				INVALID_TOKEN_ERR: "您的帐号已在另一台设备登陆，请重新登陆",
				SUBMIT_CREATE_BRANCH: "提交成功，等待审核",
				PAGE_NODATA: "没有数据啦~",
				PAGE_LOADING: '<span class="mui-spinner"></span>加载数据...',
			},
		},
		/****** url配置 *****/
		urlCONFIG: {
			get_index: webHost + 'index.html',
			ttt: webHost + "view/test/forget_password.html",

			common: {
				url: { 
					update_path: upHost + '/_app_danding', //获取app版本号
					location: webHost + "common/account/location.html",
					webview_embed: webHost + "common/webview/plus/webview_embed.html",
					webview: webHost + "view/common/webview.html",//打开外部链接
					detailcontent: webHost + "view/common/detailcontent.html",//打开外部链接
					info_comment: webHost + "view/common/info_comment.html", //评论
					info_image: webHost + "view/common/info_image.html", //视频详情
					info_video: webHost + "view/common/info_video.html", //图标详情
					info_giftlist: webHost + "view/common/info_giftlist.html", //资源礼品
					search: webHost + "view/common/search.html", //查询数据 
					info_accusation: webHost + "view/common/info_accusation.html", //举报
					info_forward: webHost + "view/common/info_forward.html", //分享
					stars: webHost + 'view/common/stars.html', //明星
					soar: webHost + 'view/common/soar.html', //飙升
					popularity: webHost + 'view/common/popularity.html', //人气
					fans: webHost + 'view/common/fans.html', //粉丝
					starhome: webHost + 'view/common/starhome.html', //明星主页
					select_kungfustar: webHost + 'view/common/select_kungfustar.html', //搜索武术明星
					select_calligraphystar: webHost + 'view/common/select_calligraphystar.html', //搜索书法明星
				},
				api: {
					SendValidateCode: apiHost + 'api/Comm/SendValidateCode', //获取验证码
					QueryConfigByKey: apiHost + "api/Comm/QueryConfigByKey/[userid]/[key]", //查询配置
					api_Dictionaries_QueryByParentNo: apiHost + 'api/Dictionaries/QueryByParentNo', //查询字典
					api_FileUpload_UpLoadProcess: apiHost + 'api/FileUpload/UpLoadProcess', //上传图片视频文件等
					api_FileUpload_UpLoadImgHtml5: apiHost + 'api/FileUpload/UpLoadImgHtml5', //Html5上传图片
					api_FileUpload_UpLoadProcessImg: apiHost + 'api/FileUpload/UpLoadProcessImg', //APP上传图片
					GetAdministrativeArea: apiHost + 'api/comm/GetAdministrativeArea',
					api_College_AddCollection: apiHost + 'api/College/AddCollection',
					api_College_DelsyCollection: apiHost + 'api/College/DelsyCollection',
					QueryMyWallet: apiHost + "api/User/QueryMyWallet/[userid]/[key]", //我的钱包
					QueryWalletList: apiHost + "api/User/QueryWalletList/[userid]/[key]", //我的钱包明细
					QueryTypeByParentNo: apiHost + 'api/Dictionaries/QueryTypeByParentNo',
					QueryStarhome: apiHost + 'api/yd/QueryStarhome/[userid]/[key]',
					QueryInfoListForSysMessage: apiHost + "api/comm/QueryInfoListForSysMessage/[userid]/[key]",
					QueryInfoForSysMessage: apiHost + "api/comm/QueryInfoForSysMessage/[userid]/[key]",
					GetNewSysMessageCount: apiHost + "api/comm/GetNewSysMessageCount/[userid]/[key]",
					CheckIosShengji: apiHost + "api/comm/CheckIosShengji",
					QueryInfoForXunZ: apiHost + "api/comm/QueryInfoForXunZ",
					QueryAllStarsList:apiHost+"api/yd/QueryAllStarsList",
					QueryUserSendGif:apiHost+"api/RiResourcesInfo/QueryUserSendGif/[userid]/[key]",
					QueryUserReceivedGit:apiHost+"api/RiResourcesInfo/QueryUserReceivedGit/[userid]/[key]"
				},
			},
			mine: {
				url: {
					my_setting: webHost + "view/mine/my_setting.html",
					my_release: webHost + "view/mine/my_release.html",
					my_collect: webHost + "view/mine/my_collect.html",
					my_history: webHost + "view/mine/my_history.html",
					my_feedback: webHost + "view/mine/my_feedback.html",
					my_gift: webHost + "view/mine/my_gift.html",
					my_wallet: webHost + "view/mine/my_wallet.html",
					my_comment: webHost + "view/mine/my_comment.html",
					my_recharge: webHost + "view/mine/my_recharge.html",
					my_walletdetail: webHost + "view/mine/my_walletdetail.html",
					my_carestars: webHost + "view/mine/my_carestars.html",
					vip: webHost + "view/pay/vip.html",
					starcertification: webHost + 'view/mine/starcertification.html',
					sys_message: webHost + 'view/mine/sys_message.html',
					sys_messagedetail: webHost + 'view/mine/sys_messagedetail.html',
					sys_setting: webHost + 'view/mine/sys_setting.html',
					my_xzcj: webHost + 'view/mine/my_xzcj.html',
					mywithdrawals: webHost + "view/mine/mywithdrawals.html",
					withdrawals_app: webHost + "view/mine/withdrawals_app.html",
					bindingbank: webHost + "view/mine/bindingbank.html",
					my_video:webHost+'view/mine/my_video.html',

				},
				api: {

					QueryMyIntegralList: apiHost + 'api/user/QueryMyIntegralList/[userid]/[key]', //查询数据 我的积分
					QueryMyElectronicList: apiHost + 'api/user/QueryMyElectronicList/[userid]/[key]', //我的余额
					SetPayPassword: apiHost + 'api/user/SetPayPassword/[userid]/[key]', //设置支付密码
					QueryFeedBackList: apiHost + "api/user/QueryFeedBackList_Api/[userid]/[key]", //评论列表
					SaveFeedBack: apiHost + 'api/user/SaveFeedBack/[userid]/[key]', //保存反馈

					SaveNickName: apiHost + "api/user/SaveNickName/[userid]/[key]", //保存昵称
					SaveSex: apiHost + "api/user/SaveSex/[userid]/[key]", //保存性别
					SaveTel: apiHost + "api/user/SaveTel/[userid]/[key]", //绑定手机号码
					DelTel: apiHost + "api/user/DelTel/[userid]/[key]", //解绑手机号码
					SaveArea: apiHost + "api/user/SaveArea/[userid]/[key]", //保存常住地
					SaveBirthday: apiHost + "api/user/SaveBirthday/[userid]/[key]", //保存生日
					SaveAutograph: apiHost + "api/user/SaveAutograph/[userid]/[key]", //保存个人签名
					SaveHeaderImgUrl: apiHost + "api/user/SaveHeaderImgUrl/[userid]/[key]", //保存个人图像
					QueryCertificationList: apiHost + "api/user/QueryCertificationList/[userid]/[key]", //获取认证信息
					QueryUserQrCode: apiHost + "api/user/QueryUserQrCode/[userid]/[key]", //获取用户验证码
					QueryUserCollection: apiHost + 'api/RiResourcesInfo/QueryUserCollection/[userid]/[key]', //查询我的收藏
					QueryUserComment: apiHost + 'api/RiResourcesInfo/QueryUserComment/[userid]/[key]', //查询我的评论
					QueryUserView: apiHost + 'api/RiResourcesInfo/QueryUserView/[userid]/[key]', //查询我的历史记录

					MemberUpVip: apiHost + 'api/yd/MemberUpVip/[userid]/[key]', //升級vip
					CareStar: apiHost + 'api/yd/CareStar/[userid]/[key]', //关注明星
					CancelCareStar: apiHost + 'api/yd/CancelCareStar/[userid]/[key]', //取消关注明星
					GetFansCount: apiHost + 'api/yd/GetFansCount/[userid]/[key]', //获取粉丝数量
					Starcertification_App: apiHost + "api/yd/Starcertification_App/[userid]/[key]", //申请明星认证
					Check_App: apiHost + "api/yd/Check_App/[userid]/[key]", //申请明星认证检查

					QueryMyCareStarsList: apiHost + 'api/yd/QueryMyCareStarsList/[userid]/[key]', //我关注d明星
					QueryMyPopularityValue: apiHost + 'api/yd/QueryMyPopularityValue/[userid]/[key]',
					QueryMyPopularityOrder: apiHost + 'api/yd/QueryMyPopularityOrder/[userid]/[key]',
					QueryMySoarOrder: apiHost + 'api/yd/QueryMySoarOrder/[userid]/[key]',
					IsCareRelation: apiHost + 'api/yd/IsCareRelation/[userid]/[key]',
					Withdrawals_App: apiHost + 'api/yd/Withdrawals_App/[userid]/[key]',
					QueryWithdrawalsList_Api: apiHost + 'api/yd/QueryWithdrawalsList_Api/[userid]/[key]',
					RevokeWithdrawals: apiHost + 'api/yd/RevokeWithdrawals/[userid]/[key]',
				    SaveMyBankno: apiHost + "api/user/SaveMyBankno/[userid]/[key]", //保存银行卡信息

					QueryStarResource: apiHost + 'api/RiResourcesInfo/QueryStarResource/[userid]/[key]', //查询明星对应的记录
					AlipayElectronicRecharge:apiHost + 'api/User/AlipayElectronicRecharge/[userid]/[key]', //支付宝充值
					WXElectronicRecharge:apiHost + 'api/User/WXElectronicRecharge/[userid]/[key]', //微信充值

				}
			},
			login: {
				url: {
					login: webHost + "view/login/login.html",
					register: webHost + "view/login/register.html",
					forget_password: webHost + "view/login/forget_password.html",
				},
				api: {
					api_User_Login: apiHost + 'api/User/Login', //用户登录
					api_User_Register: apiHost + 'api/User/Register', //注册
					api_User_UpdatePassword: apiHost + 'api/User/UpdatePassword', //修改密码
					UserIDLogin: apiHost + 'api/User/UserIDLogin', //用户登录
                    UpdateLastLoginTime:apiHost+'api/User/UpdateLastLoginTime',//更新最新登录时间
				}
			},
			recommend: {
				url: {
					toplines_detail: webHost + "view/recommend/toplines_detail.html", //头条详细页面
				},
				api: {

				}
			},
			resourceinfo: {
				url: {
					index: webHost + "circle/index.html", //
					vedio_detail: webHost + "circle/resourcesinfo/vedio_detail.html", //视频详情
					image_detail: webHost + "circle/resourcesinfo/image_detail.html", //图标详情
					forward_detail: webHost + "circle/resourcesinfo/forward_detail.html", //分享
					recommendlist: webHost + "circle/resourcesinfo/recommend_list.html", //推荐
					resourcesinfolist: webHost + "circle/resourcesinfo/resourcesinfo_list.html", //资讯列表	
					resourcesgift_list: webHost + "circle/resourcesinfo/resourcesgift_list.html", //礼品列表									
					rank_list: webHost + "circle/resourcesinfo/rank_list.html", //排行榜单: 
					resources_search: webHost + "circle/resourcesinfo/resources_search.html", //资讯检索列表
					toplines_detail: webHost + "circle/resourcesinfo/toplines_detail.html", //头条详情
					

				},
				api: {
					api_RiAdvertisement_QueryAdByType: apiHost + 'api/RiAdvertisement/QueryAdByType', //页面广告

					api_RiResourcesInfo_QueryList: apiHost + 'api/RiResourcesInfo/QueryList/[userid]/[key]', //查询资讯
					api_RiResourcesInfo_QueryHotList: apiHost + 'api/RiResourcesInfo/QueryHotList/[userid]/[key]', //热搜榜					
					api_RiResourcesInfo_QueryChoicenessList: apiHost + 'api/RiResourcesInfo/QueryChoicenessList/[userid]/[key]', //精选
					api_RiResourcesInfo_QueryRecommendList: apiHost + 'api/RiResourcesInfo/QueryRecommendList/[userid]/[key]', //精选
					api_RiResourcesInfo_QueryDetailRecommendList: apiHost + 'api/RiResourcesInfo/QueryDetailRecommendList/[userid]/[key]', //详情推荐
					api_RiResourcesInfo_QueryResuourceByID: apiHost + 'api/RiResourcesInfo/QueryResuourceByID/[userid]/[key]', //查询单条
					api_RiResourcesInfo_QueryCommentList: apiHost + 'api/RiResourcesInfo/QueryCommentList/[userid]/[key]', //查询评论

					api_RiResourcesInfo_AddThumbUp: apiHost + 'api/RiResourcesInfo/AddThumbUp/[userid]/[key]', //点赞 
					api_RiResourcesInfo_AddCollection: apiHost + 'api/RiResourcesInfo/AddCollection/[userid]/[key]', //添加收藏
					api_RiResourcesInfo_DelsyCollection: apiHost + 'api/RiResourcesInfo/DelsyCollection/[userid]/[key]', //删除收藏
					api_RiResourcesInfo_AddAccusation: apiHost + 'api/RiResourcesInfo/AddAccusation/[userid]/[key]', //删除收藏
					
					api_RiResourcesInfo_AddStepOn: apiHost + 'api/RiResourcesInfo/AddStepOn/[userid]/[key]', //踩 
					api_RiResourcesInfo_AddComment: apiHost + 'api/RiResourcesInfo/AddComment/[userid]/[key]', //添加评论
					api_RiResourcesInfo_AddCommentThumbUp: apiHost + 'api/RiResourcesInfo/AddCommentThumbUp/[userid]/[key]', //添加评论
					api_RiResourcesInfo_Share: apiHost + 'api/RiResourcesInfo/Share/[userid]/[key]', //转载
					api_RiResourcesInfo_QueryVirtualGifts: apiHost + 'api/RiResourcesInfo/QueryVirtualGifts/[userid]/[key]', //查询虚拟礼品
					api_RiResourcesInfo_AddResourcesGift: apiHost + 'api/RiResourcesInfo/AddResourcesGift/[userid]/[key]', //赠送礼品
					api_RiResourcesInfo_QueryResourcesGiftTop: apiHost + 'api/RiResourcesInfo/QueryResourcesGiftTop/[userid]/[key]', //查询赠送礼品总数与前几条
					api_RiResourcesInfo_QueryResourcesGift: apiHost + 'api/RiResourcesInfo/QueryResourcesGift/[userid]/[key]', //查询赠送礼品

					api_SysInformation_QueryTopLines: apiHost + 'api/SysInformation/QueryTopLines', //查询头条
					api_SysInformation_QueryTopLinesInfo: apiHost + 'api/SysInformation/QueryTopLinesInfo', //查询头条
					api_SysInformation_QueryTopLinesTop: apiHost + 'api/SysInformation/QueryTopLinesTop', //查询头条设置最前两条
					

				},

			},
			order: {
				api: {
					QueryFansOrderListTake3: apiHost + 'api/yd/QueryFansOrderListTake3/[userid]/[key]', //查询前3粉丝排行榜
					QueryFansOrderListTake20: apiHost + 'api/yd/QueryFansOrderListTake20/[userid]/[key]', //查询前20粉丝排行榜

					QuerySoarOrderListTake3: apiHost + 'api/yd/QuerySoarOrderListTake3/[userid]/[key]',
					QuerySoarOrderListTake20: apiHost + 'api/yd/QuerySoarOrderListTake20/[userid]/[key]',
					QueryPopularityOrderListTake3: apiHost + 'api/yd/QueryPopularityOrderListTake3/[userid]/[key]',
					QueryPopularityOrderListTake20: apiHost + 'api/yd/QueryPopularityOrderListTake20/[userid]/[key]',
					QueryPopularityWeekOrderListTake20: apiHost + 'api/yd/QueryPopularityWeekOrderListTake20/[userid]/[key]',
					QueryPopularityMonthOrderListTake20: apiHost + 'api/yd/QueryPopularityMonthOrderListTake20/[userid]/[key]',

					QueryKFSoarOrderListTake3: apiHost + 'api/yd/QueryKFSoarOrderListTake3/[userid]/[key]',
					QueryKFSoarOrderListTake20: apiHost + 'api/yd/QueryKFSoarOrderListTake20/[userid]/[key]',
					QueryKFPopularityOrderListTake3: apiHost + 'api/yd/QueryKFPopularityOrderListTake3/[userid]/[key]',
					QueryKFPopularityOrderListTake20: apiHost + 'api/yd/QueryKFPopularityOrderListTake20/[userid]/[key]',
					QueryKFPopularityWeekOrderListTake20: apiHost + 'api/yd/QueryKFPopularityWeekOrderListTake20/[userid]/[key]',
					QueryKFPopularityMonthOrderListTake20: apiHost + 'api/yd/QueryKFPopularityMonthOrderListTake20/[userid]/[key]',

					QuerySFRecommendAPI: apiHost + 'api/yd/QuerySFRecommendAPI/[userid]/[key]',
					QueryWSRecommendAPI: apiHost + 'api/yd/QueryWSRecommendAPI/[userid]/[key]',
				}
			}
		},
	}
})