//模块配置
require.config({
	baseUrl: '../../js',
	urlArgs: "bust=" + (new Date()).getTime(),
	paths: {
		'jquery': 'libs/jquery.min',
		'mui': 'libs/mui/mui.min',
		'layer': 'libs/layer/layer',
		'_': 'libs/underscore-min',
		'common': 'common'
	},
	shim: {
		'jquery': {
			exports: '$'
		},
		'mui': {
			exports: 'mui'
		},
		'_': {
			exports: '_'
		},
		'layer': {
			deps: ['jquery'],
			exports: 'layer'
		}
	}
});